/*
 * Osoba.java
 *
 * Created on 22 kwiecień 2007, 21:48
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package grupa01;

import java.sql.Date;
import java.util.Comparator;

/**
 *
 * @author arkadiusz
 */
public class Osoba
  implements Comparable //wymagany kawałek kodu. Wart 1pkt.!
{
  
  private int wiek;
  private String nazwisko;
  private String imie;
  /**
   * Creates a new instance of Osoba
   */
  public Osoba() {
    this.wiek = 0;
    this.nazwisko = null;
    this.imie = null;   
    /*
     *Niektóży z was inicjowali jakimiś startowymi wartościami
     *Nie jest to źle ale czasem trudniej wyłapać gdzie jest błąd
     *w programie.
     */
  }
  public Osoba(String nazwisko, String imie, int wiek){
    /*
     *Poniższe to to czego oczkiwałem w przybliżeniu     *
     */
    if(wiek < 0 )
      System.err.println("Wiek nie może być ujemny!");
    
    /*
     *Oczywiście można było wyżucić wyjątek.
     *Pniższy kod robi to samo ale rzuca wyjątki.
     *Oczywiście albo to u góry albo to poniżej.
     */
    if(wiek < 1900 )
      throw new RuntimeException("Zły wiek!");
    
    //Standadowo przypisanie wartości argumentów konstruktora
    //do pól klasy.
    this.wiek = wiek;
    this.nazwisko = nazwisko;
    this.imie = imie;
    
  }
  /**
   * Metoda zmieniająca wartość pola numerTelefonu.
   */
  public String przedstawSie(){
    //niektórzy pisali tak:
    System.out.print("Nazywam się: " + this.imie + " " + this.nazwisko);    
    //trzeba było tak. Ale jak było tak jak powyżej to też znawałem, że ok.
    return "Nazywam się: " + this.imie + " " + this.nazwisko;
    
    
  }
  /**
   * Metoda zwracajaca wiek.
   */
  public int ileLat() {
    //komentaż taki jak w przedstawSię()
    System.out.print("Mam lat: " + this.wiek);    
    
    return this.wiek;
    
    
  }
  /**
   * implementacja funkcji wymaganej przez intefejs Comparable
   * sortuje w kolejności po numerach telefonów i po roku prdukcji
   */
  public int compareTo(Object o) {
    
    //tworzymy referencję pomocniczą
     Osoba os = (Osoba)o;
    return os.wiek - this.wiek;
  }
  /*
   *NIE OBOWIĄZKOWE, lecz niekórzy próbowali coś takiego robić
   */
  /*tworzymy obiekt sortByRok typu Comparator, by móc go użyć
   *w Arrays.sort() jako obiekt statyczny, by móc użyć 
   *bez potrzeby tworzenia osobno obiektu. Tworzymy klasę anonimową
   *z użyciem typu generycznego.
   */
  public static Comparator 
    sortByWiek = new Comparator<Osoba>(){
    //dzięki typowi generycznemu poniższa metoda ma jako argument
    // dwa obiekty typu Osoba
    public int compare(Osoba os1, Osoba os2) {
      return os1.wiek - os2.wiek;    
    }
  };
  
}
