/*
 * Adres.java
 *
 * Created on 22 kwiecień 2007, 21:48
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package grupa02;

import java.sql.Date;
import java.util.Comparator;

/**
 *
 * @author arkadiusz
 */
public class Adres
  implements Comparable //wymagany kawałek kodu. Wart 1pkt.!
{
  private int nrMieszkania; 
  private int nrDomu;
  private String ulica;
  private String miasto;
  /**
   * Creates a new instance of Adres
   */
  public Adres() {
    this.nrDomu = 0;
    this.ulica = null;
    this.miasto = null;
    this.nrMieszkania = 0;
    /*
     *Niektóży z was inicjowali jakimiś startowymi wartościami
     *Nie jest to źle ale czasem trudniej wyłapać gdzie jest błąd
     *w programie.
     */
  }
  public Adres(String miasto, String ulica, int nrDomu, int nrMieszkania){
 
    /*
     *Poniższe to to czego oczkiwałem w przybliżeniu     *
     */
    if(nrDomu <= 0 )
      System.err.println("Błąd numer domu musi być większy od zera!");
    
    if(nrMieszkania <= 0)
      System.err.println("Błąd numer mieszkania musi być większy od zera!");
    /*
     *Oczywiście można było wyżucić wyjątek.
     *Pniższy kod robi to samo ale rzuca wyjątki.
     *Oczywiście albo to u góry albo to poniżej.
     */
    if(nrDomu <= 0 )
      throw new RuntimeException("Zła data!");

    if(nrMieszkania <= 0)
      throw new RuntimeException("Zły numer!");
    
    //Standadowo przypisanie wartości argumentów konstruktora
    //do pól klasy.
    this.miasto = miasto;
    this.ulica = ulica;
    this.nrDomu = nrDomu;
    this.nrMieszkania = nrMieszkania;
    
  }
  /**
   * Metoda zmieniająca wartość pola numerTelefonu.
   */
  public void setUlica(String ulica){
    if(ulica.length() == 0)
      System.err.println("nazwa ulicy jest pusta!!!");
    this.ulica = ulica;
    
  }
  /**
   * Metoda zmieniająca wartość pola dataProdukcji.
   */
  public void setNumerDomu(int nrDomu) throws Exception{
    //przykład z użyciem wyjątku. Wymaga części throws ^^^^^
    if(nrDomu <= 0 )
      throw new Exception("zły numer domu!!!");
    this.nrDomu = nrDomu;
    
  }
  /**
   * implementacja funkcji wymaganej przez intefejs Comparable
   * sortuje w kolejności po numerach telefonów i po roku prdukcji
   */
  public int compareTo(Object o) {
    
    //tworzymy referencję pomocniczą
     Adres a = (Adres)o;
    
    return this.nrDomu - a.nrDomu;
  }
  
  
  /*
   *NIE OBOWIĄZKOWE, lecz niekórzy próbowali coś takiego robić
   */
  /*tworzymy obiekt sortByRok typu Comparator, by móc go użyć
   *w Arrays.sort() jako obiekt statyczny, by móc użyć 
   *bez potrzeby tworzenia osobno obiektu. Tworzymy klasę anonimową
   *z użyciem typu generycznego.
   */
  public static Comparator 
    sortByNrDomu = new Comparator<Adres>(){
    //dzięki typowi generycznemu poniższa metoda ma jako argument
    // dwa obiekty typu Adres
    public int compare(Adres a1, Adres a2) {
      return a1.nrDomu - a2.nrDomu;    
    }
  };
  
}
